/// <reference types="cypress" />

describe("game should", () => {
  it("be able to restart itself", () => {
    cy.visit("/")
    cy.get(".div0.hole").should("be.visible")
    cy.get(".div1.pole").should("be.visible")
    cy.get(".div2.pole").should("be.visible").click()
    cy.get(".div2.pick").should("be.visible")
    cy.get(".div0.dest").should("be.visible").click()
    cy.get(".div0.pole").should("be.visible")
    cy.get(".div1.hole").should("be.visible")
    cy.get(".div2.hole").should("be.visible")
    cy.get(".restart").click()
    cy.get(".div2.pole").should("be.visible")
  })

  it("display game over", () => {
    cy.visit("/")
    cy.get("[data-cy=game-over]").as("game-over").should("not.be.visible")

    cy.get(".div2.pole").click()
    cy.get(".div0.dest").click()
    cy.get(".div11.pole").click()
    cy.get(".div2.dest").click()
    cy.get(".div4.pole").click()
    cy.get(".div11.dest").click()
    cy.get(".div3.pole").click()
    cy.get(".div1.dest").click()
    cy.get(".div0.pole").click()
    cy.get(".div2.dest").click()
    cy.get(".div8.pole").click()
    cy.get(".div6.dest").click()
    cy.get(".div12.pole").click()
    cy.get(".div5.dest").should("be.visible")
    cy.get(".div7.dest").click()
    cy.get(".div13.pole").click()
    cy.get(".div8.dest").click()
    cy.get(".div7.pole").click()
    cy.get(".div5.dest").click()
    cy.get(".div5.pole").click()
    cy.get(".div12.dest").click()
    cy.get(".div14.pole").click()
    cy.get(".div11.dest").click()

    cy.get("@game-over").should("be.be.visible")
  })

  it("display victory", () => {
    cy.visit("/")
    cy.get("[data-cy=victory]").as("victory").should("not.be.visible")

    cy.get(".div2.pole").click()
    cy.get(".div0.dest").click()
    cy.get(".div11.pole").click()
    cy.get(".div2.dest").click()
    cy.get(".div3.pole").click()
    cy.get(".div1.dest").click()
    cy.get(".div9.pole").click()
    cy.get(".div2.dest").click()
    cy.get(".div0.pole").click()
    cy.get(".div9.dest").click()
    cy.get(".div13.pole").click()
    cy.get(".div8.dest").click()
    cy.get(".div14.pole").click()
    cy.get(".div11.dest").click()
    cy.get(".div1.pole").click()
    cy.get(".div3.dest").click()
    cy.get(".div5.pole").click()
    cy.get(".div12.dest").click()
    cy.get(".div12.pole").click()
    cy.get(".div7.dest").click()
    cy.get(".div4.pole").click()
    cy.get(".div2.dest").click()
    cy.get(".div2.pole").click()
    cy.get(".div9.dest").click()
    cy.get(".div8.pole").click()
    cy.get(".div13.dest").click()

    cy.get("@victory").should("be.visible")
  })

  // 2>0  11>2  3>1  9>2  0>9  13>8  14>11  1>3  5>12  12>7  4>2  2>9  8>13
})
